<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value, endDate)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    {{ value | formatDate }}
    <template v-slot:dialog>
      <div class="pt-3">
        <v-form
          ref="form"
          @submit.prevent
        >
          <raw-date-picker-single-field
            :value="value"
            :max="endDate"
            @input="emitValueToParent"
          />
        </v-form>
      </div>
    </template>
  </crud-data-table-update>
</template>

<script>
  import commonMessages from '../../commonMessages'
  import DatesMixin from '@/mixins/date'

  export default {
    name: 'EditStartDateDialog',
    mixins: [DatesMixin],
    inheritAttrs: false,
    props: {
      value: String,
      itemId: {
        type: Number,
        required: true,
      },
      endDate: {
        type: String,
        required: true,
      },
    },
    methods: {
      onSave (startDate, endDate) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('periods/updatePeriodStartDate', {
            ID: this.itemId,
            startDate,
            endDate,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      sharedMessages: commonMessages,
    },
  }
</script>
